"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DefaultCacheStore = void 0;
var DefaultCacheStore = /** @class */ (function () {
    function DefaultCacheStore() {
        this.store =
            typeof window !== 'undefined'
                ? window.localStorage
                : stubbedLocalStorage;
    }
    DefaultCacheStore.prototype.save = function (storeKey, data) {
        var _a;
        (_a = this.store) === null || _a === void 0 ? void 0 : _a.setItem(storeKey, JSON.stringify(data));
    };
    DefaultCacheStore.prototype.load = function (storeKey) {
        var _this = this;
        return new Promise(function (resolve) {
            var _a;
            var item = (_a = _this.store) === null || _a === void 0 ? void 0 : _a.getItem(storeKey);
            resolve(item ? JSON.parse(item) : null);
        });
    };
    DefaultCacheStore.prototype.remove = function (storeKey) {
        var _a;
        (_a = this.store) === null || _a === void 0 ? void 0 : _a.removeItem(storeKey);
    };
    return DefaultCacheStore;
}());
exports.DefaultCacheStore = DefaultCacheStore;
var stubbedLocalStorage = {
    getItem: function () { return null; },
    setItem: function () { return undefined; },
    removeItem: function () { return undefined; },
    clear: function () { return undefined; },
    key: function () { return null; },
    length: 0,
};
exports.default = DefaultCacheStore;
//# sourceMappingURL=DefaultCacheStore.js.map