"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DefaultStorage = void 0;
var DefaultStorage = /** @class */ (function () {
    function DefaultStorage() {
        this.store =
            typeof window !== 'undefined'
                ? window.localStorage
                : stubbedLocalStorage;
    }
    DefaultStorage.prototype.save = function (storeKey, data) {
        this.store.setItem(storeKey, JSON.stringify(data));
    };
    DefaultStorage.prototype.load = function (storeKey) {
        var _this = this;
        return new Promise(function (resolve) {
            var item = _this.store.getItem(storeKey);
            resolve(item ? JSON.parse(item) : undefined);
        });
    };
    DefaultStorage.prototype.remove = function (storeKey) {
        this.store.removeItem(storeKey);
    };
    return DefaultStorage;
}());
exports.DefaultStorage = DefaultStorage;
var stubbedLocalStorage = {
    getItem: function () { return null; },
    setItem: function () { return undefined; },
    removeItem: function () { return undefined; },
    clear: function () { return undefined; },
    key: function () { return null; },
    length: 0,
};
exports.default = DefaultStorage;
//# sourceMappingURL=DefaultStorage.js.map